<template>
    <section class="section">
        <div class="container is-fluid">
        <b-table
            :data="articlesData"
            :bordered="isBordered"
            :striped="isStriped"
            :narrowed="isNarrowed"
            :selectable="isSelectable"
            :checkable="isCheckable"
            :mobile-cards="hasMobileCards"
            :paginated="isPaginated"
            :per-page="perPage"
            :pagination-simple="isPaginationSimple"
            :backend-sorting="isBackendSort"
            render-html
            @check="checked"
            @select="selected"
            @sort="sorted">

            <b-table-column field="title" label="Title" sortable></b-table-column>
            <b-table-column field="content" label="Content" sortable></b-table-column>
            <b-table-column field="createdAt" label="Date" sortable :format="formatDate"></b-table-column>
            <b-table-column field="status" label="Status"></b-table-column>

        </b-table>

        <div class="level">
            <div class="level-left">
                <div class="level-item"></div>
            </div>
            <div class="level-right">
                <div class="level-item">
                    <b-pagination
                        :total="pgTotal"
                        :current="pgCurrent"
                        :order="paging.order"
                        :size="paging.size"
                        :simple="paging.isSimple"
                        :per-page="pgPerPage"
                        @change="pageChanged">
                    </b-pagination>
                </div>
            </div>
        </div>

        </div>
    </section>
</template>

<script>
import { mapState } from 'vuex'

export default {
    layout: 'admin',
    data() {
        return {
            checkItems: [],
            selItem: {},
            isBordered: false,
            isStriped: false,
            isNarrowed: false,
            isSelectable: false,
            isCheckable: true,
            hasMobileCards: true,
            isPaginated: false,
            isPaginationSimple: false,
            isBackendSort: true,
            perPage: 10,

            tableOrder: {
                page: 1,
                sort: null 
            },

            paging: {
                order: '',
                size: '',
                isSimple: false
            }
        }
    },
    computed: mapState({
        articlesData: (state) => state.admin_articles.data,
        pgTotal: (state) => state.admin_articles.total,
        pgPerPage: (state) => state.admin_articles.limit,
        pgCurrent: (state) => state.admin_articles.currentPage
    }),
    methods: {
        checked(items, item) {
            this.checkItems = items
        },
        selected(item) {
            this.selItem = item
        },
        sorted(field, order) {
            this.tableOrder.page = this.pgCurrent
            this.tableOrder.sort = {
                                        field,
                                        order: (order === 'asc') ? 1 : -1
                                    }
            this.$store.dispatch('ADMIN_FETCH_ARTICLES', this.tableOrder)
        },
        formatDate(value, row) {
            return `<span class="tag is-primary">
                ${new Date(value).toLocaleDateString()}
            </span>`
        },
        pageChanged(value) {
            this.pgCurrent = value
            this.tableOrder.page = this.pgCurrent
            this.$store.dispatch('ADMIN_FETCH_ARTICLES', this.tableOrder)
        }
    }
}
</script>

<style scoped>

</style>